﻿-- **********************************************************************
-- GnomTEC Gnomcorder
-- Version: 7.0.3.27
-- Author: GnomTEC
-- Copyright 2011-2016 by GnomTEC
-- http://www.gnomtec.de/
-- **********************************************************************
-- load localization first.
local L = LibStub("AceLocale-3.0"):GetLocale("GnomTEC_Gnomcorder")

local CONST_BATTERY_FULL = 10000
local CONST_BATTERY_5_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_5"
local CONST_BATTERY_5_MINVALUE = 0.8 * CONST_BATTERY_FULL
local CONST_BATTERY_4_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_4"
local CONST_BATTERY_4_MINVALUE = 0.3 * CONST_BATTERY_FULL
local CONST_BATTERY_3_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_3"
local CONST_BATTERY_3_MINVALUE = 0.2 * CONST_BATTERY_FULL
local CONST_BATTERY_2_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_2"
local CONST_BATTERY_2_MINVALUE = 0.1 * CONST_BATTERY_FULL
local CONST_BATTERY_1_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_1"
local CONST_BATTERY_1_MINVALUE = 0.0 * CONST_BATTERY_FULL
local CONST_BATTERY_0_TEXTURE = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\Battery_0"

local CONST_BATTERY_CONSUMPTION_BUTTONCLICK	= 1
local CONST_BATTERY_CONSUMPTION_DISPLAYCHANGE = 10
local CONST_BATTERY_CONSUMPTION_MODULEPERHOUR = 100
local CONST_BATTERY_CONSUMPTION_MODULECALL = 10

local CONST_BATTERY_RECHARGEPERSECOND = 100

local CONST_BATTERY_RECHARGER_NPC = {
	["NPC_5518"] = L["L_NPC_5518"],
	["NPC_5174"] = L["L_NPC_5174"],
	["NPC_1646"] = L["L_NPC_1646"],
}

local battery_startup_energy
local battery_startup_time
local battery_lasttime_energy
local battery_lasttime_time
local battery_recharging = nil
local battery_blink = nil
local actualButtonbar = 1
local settingsPosition = 0


GnomTEC_Gnomcorder_Options = {
	["ShowDisplay"] = true,
	["HideAll"] = false,	
	["Battery"] = CONST_BATTERY_1_MINVALUE + (CONST_BATTERY_2_MINVALUE-CONST_BATTERY_1_MINVALUE)/2,
}

GnomTEC_Gnomcorder_Buttons = {
	["GnomTEC Gnomcorder"] = {
		["Empty"] = {
			ButtonText = "Leer",
			Frame = nil,
			NormalTexture = "Interface\\BUTTONS\\ButtonHilight-Square",
			CheckedTexture = "Interface\\BUTTONS\\ButtonHilight-Square",
			Checked = nil,
			OnClick = nil,
			TimerEvent = nil,
		},
	},
}

GnomTEC_Gnomcorder_IconbarButtons = {
	["Buttonbar1"] = {
		["Button1"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button2"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button3"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button4"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button5"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button6"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
	},
	["Buttonbar2"] = {
		["Button1"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button2"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button3"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button4"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button5"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
		["Button6"] = {
			["ModuleName"] = nil,
			["ButtonName"] = nil,
		},
	},	
}

local lastFrame = nil

local optionsMain = {
	name = "GnomTEC Gnomcorder",
	type = "group",
	args = {
		descriptionTitle = {
			order = 1,
			type = "description",
			name = L["L_OPTIONS_TITLE"],
		},
		descriptionAbout = {
			name = "About",
			type = "group",
			guiInline = true,
			order = 2,
			args = {
				descriptionVersion = {
				order = 1,
				type = "description",			
				name = "|cffffd700".."Version"..": ".._G["GREEN_FONT_COLOR_CODE"]..GetAddOnMetadata("GnomTEC_Gnomcorder", "Version"),
				},
				descriptionAuthor = {
					order = 2,
					type = "description",
					name = "|cffffd700".."Autor"..": ".."|cffff8c00".."GnomTEC",
				},
				descriptionEmail = {
					order = 3,
					type = "description",
					name = "|cffffd700".."Email"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."info@gnomtec.de",
				},
				descriptionWebsite = {
					order = 4,
					type = "description",
					name = "|cffffd700".."Website"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."http://www.gnomtec.de/",
				},
				descriptionLicense = {
					order = 5,
					type = "description",
					name = "|cffffd700".."Copyright"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."(c)2011-2016 by GnomTEC",
				},
			}
		},
		descriptionLogo = {
			order = 5,
			type = "description",
			name = "",
			image = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\GnomTEC-Logo",
			imageCoords = {0.0,1.0,0.0,1.0},
			imageWidth = 512,
			imageHeight = 128,
		},
	}
}
			
GnomTEC_Gnomcorder = LibStub("AceAddon-3.0"):NewAddon("GnomTEC_Gnomcorder", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceSerializer-3.0")
LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Gnomcorder Main", optionsMain)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Gnomcorder Main", "GnomTEC Gnomcorder");

LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GnomTEC_Gnomcorder", {
	type = "launcher",
	icon = "Interface\\ICONS\\INV_Misc_EngGizmos_20",
	label = "Gnomcorder",
	OnClick = function(clickedframe, button)
		if (GNOMTEC_GNOMCORDER_FRAME:IsShown()) then
			GNOMTEC_GNOMCORDER_FRAME:Hide()
			GnomTEC_Gnomcorder_Options["HideAll"] = true
		else
			GNOMTEC_GNOMCORDER_FRAME:Show()
			GnomTEC_Gnomcorder_Options["HideAll"] = false			
		end
	end,
	OnTooltipShow = function(GameTooltip)
		GameTooltip:AddLine("Show/Hide GnomTEC Gnomcorder")
	end,
})


local function emptynil( x ) return x ~= "" and x or nil end

function GnomTEC_Gnomcorder:OnInitialize()
 	-- Code that you want to run when the addon is first loaded goes here.
  
  	GnomTEC_Gnomcorder:Print(L["L_WELCOME"])
  	  	
end

function GnomTEC_Gnomcorder:OnEnable()
    -- Called when the addon is enabled

	GnomTEC_Gnomcorder:Print(L["L_ENABLED"])

	-- Initialize options which are propably not valid because they are new added in new versions of addon
	if (GnomTEC_Gnomcorder_Options["Battery"] == nil) then
		GnomTEC_Gnomcorder_Options["Battery"] = CONST_BATTERY_1_MINVALUE + (CONST_BATTERY_2_MINVALUE-CONST_BATTERY_1_MINVALUE)/2
	end

	if (GnomTEC_Gnomcorder_Options["HideAll"] == nil) then
		GnomTEC_Gnomcorder_Options["HideAll"] = false
	end
	
	
	
	-- set local parameters
	battery_startup_energy = GnomTEC_Gnomcorder_Options["Battery"]
	battery_startup_time = GetTime()
	battery_lasttime_energy = battery_startup_energy
	battery_lasttime_time = battery_startup_time
	lastFrame = GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY
	
	-- delete parts of saved button data which has to be initialized by addons
	local keyM, valueM
	for keyM,valueM in pairs(GnomTEC_Gnomcorder_Buttons) do
		local keyB, valueB
		for keyB,valueB in pairs(valueM) do
			valueB.Frame = nil
			valueB.OnClick = nil
			valueB.TimerEvent = nil
		end
	end
		
	-- set buttons on iconbar
	local i
	local emptyBar = true
	for i=1,6,1 do
		GnomTEC_Gnomcorder:SetIconbarButton(actualButtonbar, i, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ModuleName, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ButtonName)
		emptyBar = emptyBar and (nil == GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ModuleName)
	end

	-- initialize events
	GnomTEC_Gnomcorder:RegisterEvent("PLAYER_TARGET_CHANGED");
		
	-- Show GUI
	if (GnomTEC_Gnomcorder_Options["HideAll"]) then
		GNOMTEC_GNOMCORDER_FRAME:Hide()
	else
		GNOMTEC_GNOMCORDER_FRAME:Show()
	end
	GnomTEC_Gnomcorder:DisplayOnOff()
	GnomTEC_Gnomcorder:UpdateBattery()

	-- if no button is configured then "click" on settings
	if (emptyBar) then
		GnomTEC_Gnomcorder:IconbarOnClick(10)
	end
end

function GnomTEC_Gnomcorder:OnDisable()
    -- Called when the addon is disabled
    GNOMTEC_GNOMCORDER_FRAME:Hide()
    GnomTEC_Gnomcorder:UnregisterAllEvents();
end

local lastTimerEvent = 0

function GnomTEC_Gnomcorder:TimerEvent()
	local t = GetTime()
	
	-- call module timer events every 5 second
	if ((t-lastTimerEvent) > 5) then
		local keyM, valueM
		for keyM,valueM in pairs(GnomTEC_Gnomcorder_Buttons) do
			local keyB, valueB
			for keyB,valueB in pairs(valueM) do
				if valueB.TimerEvent then
					valueB.TimerEvent()
				end
			end
		end
		lastTimerEvent = t
	end	
	
	-- battery handling	
	if (t-battery_lasttime_time > 60) then
		GnomTEC_Gnomcorder:UpdateBattery()
	end

	if (battery_recharging and ((t-battery_recharging) > 1)) then
		GnomTEC_Gnomcorder:RechargeBattery(CONST_BATTERY_RECHARGEPERSECOND)
		GnomTEC_Gnomcorder:UpdateBattery()
		battery_recharging = t
	end

	if (battery_blink and (t-battery_blink > 1)) then
		if (0 == (floor(t) % 2)) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
		else	
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:LockHighlight();
		end
		battery_blink = t
	end	
end

function GnomTEC_Gnomcorder:PLAYER_TARGET_CHANGED(eventName)
--[[ general code for GUID interpretation
	local guid = UnitGUID("target")	

	if (guid) then
		local first3 = tonumber("0x"..strsub(guid, 3,5))
		local unitType = bit.band(first3,0x00f)

		if (unitType == 0x000) then
   			GnomTEC_Gnomcorder:Print("Player, ID #", strsub(guid,6))
		elseif (unitType == 0x003) then
			local creatureID = tonumber("0x"..strsub(guid,7,10))
			local spawnCounter = tonumber("0x"..strsub(guid,11))
			GnomTEC_Gnomcorder:Print("NPC, ID #",creatureID,"spawn #",spawnCounter)
		elseif (unitType == 0x004) then
			local petID = tonumber("0x"..strsub(guid,7,10))
			local spawnCounter = tonumber("0x"..strsub(guid,11))
			GnomTEC_Gnomcorder:Print("Pet, ID #",petID,"spawn #",spawnCounter)
			elseif (unitType == 0x005) then
			local creatureID = tonumber("0x"..strsub(guid,7,10))
			local spawnCounter = tonumber("0x"..strsub(guid,11))
			GnomTEC_Gnomcorder:Print("Vehicle, ID #",creatureID,"spawn #",spawnCounter)
		end
	end
--]]

    -- process the event
--[[ GUIDs are changed in 6.0.2 so this is not working anymore

	local guid = UnitGUID("target")	
   local creatureID = ""

	if (guid) then
		local first3 = tonumber("0x"..strsub(guid, 3,5))
		local unitType = bit.band(first3,0x00f)
		if (unitType == 0x003) then
    		creatureID = "NPC_"..tonumber("0x"..strsub(guid,7,10))
    	end
    end
    
    if ((CONST_BATTERY_RECHARGER_NPC[creatureID]) and (CheckInteractDistance("target", 2))) then
    	-- geeigneter NPC im Target
		 GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_RECHARGE:Enable()
    else
    	-- NPC nicht verfügbar oder nicht nahe genug
		 GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_RECHARGE:Disable()
		 battery_recharging = nil
    end
--]]
    
end

function GnomTEC_Gnomcorder:DisplayOnOff()
	
	if (GnomTEC_Gnomcorder_Options["ShowDisplay"]) then
		GNOMTEC_GNOMCORDER_FRAME:SetWidth(475)
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY:Show()
	else
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY:Hide()
		GNOMTEC_GNOMCORDER_FRAME:SetWidth(475-420)
	end
end

function GnomTEC_Gnomcorder:IconbarOnEnter(id)
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	if (id > 0) and (id < 7) then
		if (GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ModuleName) and (GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ButtonName) then
			local button = GnomTEC_Gnomcorder_Buttons[GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ModuleName][GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ButtonName]
			GameTooltip:SetText(button.ButtonText)
		else
			GameTooltip:SetText("<leer>")		
		end

	elseif (id == 0) then
		GameTooltip:SetText(L["L_BUTTONBAR_TOOLTIP_0"])
	elseif  (id == 9) then
		GameTooltip:SetText(L["L_BUTTONBAR_TOOLTIP_9"])
	elseif  (id == 10) then
		GameTooltip:SetText(L["L_BUTTONBAR_TOOLTIP_10"])
	elseif  (id == 11) then
		if (actualButtonbar > 1) then
			GameTooltip:SetText(L["L_BUTTONBAR_TOOLTIP_11"])
		else
			GameTooltip:SetText("")
		end
	elseif  (id == 12) then
		if (actualButtonbar < 2) then
			GameTooltip:SetText(L["L_BUTTONBAR_TOOLTIP_12"])
		else
			GameTooltip:SetText("")
		end		
	else
		GameTooltip:SetText("<?>")
	end
	GameTooltip:Show();
end

function GnomTEC_Gnomcorder:IconbarOnLeave(id)
	GameTooltip:Hide();
end

function GnomTEC_Gnomcorder:IconbarOnClick(id)
	GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_BUTTONCLICK)

	if (id > 0) and (id < 7) then
		if (GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ModuleName) and (GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ButtonName) then
			local button = GnomTEC_Gnomcorder_Buttons[GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ModuleName][GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..id].ButtonName]
			local checkButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BUTTON"..id]
			if button.Frame then
				GnomTEC_Gnomcorder_Options["ShowDisplay"] = true;
				GnomTEC_Gnomcorder:DisplayOnOff()
				if ((lastFrame) and (lastFrame ~= button.Frame)) then
					GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_DISPLAYCHANGE)
					lastFrame:Hide()
				end
				lastFrame = button.Frame
				lastFrame:Show();
			end
			if button.OnClick then
				GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_MODULECALL)
				button.Checked = button.OnClick(checkButton:GetChecked())
			else
				button.Checked = checkButton:GetChecked()
			end
			if (not button.Checked) then
				checkButton:SetHighlightTexture(button.NormalTexture, "ADD")
			end
			checkButton:SetCheckedTexture(button.CheckedTexture)
			if (button.Checked) then
				checkButton:SetHighlightTexture(button.CheckedTexture, "ADD")
			end
			checkButton:SetChecked(button.Checked);
		end
	elseif (id == 0) then
		GnomTEC_Gnomcorder_Options["ShowDisplay"] = not GnomTEC_Gnomcorder_Options["ShowDisplay"]
		GnomTEC_Gnomcorder:DisplayOnOff()
	elseif (id == 9) then
		-- Batterie
		GnomTEC_Gnomcorder_Options["ShowDisplay"] = true;
		GnomTEC_Gnomcorder:DisplayOnOff()
		if (lastFrame and (lastFrame ~= GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY)) then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_DISPLAYCHANGE)
			lastFrame:Hide()
		end
		GnomTEC_Gnomcorder:UpdateBattery()
		lastFrame = GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY
		lastFrame:Show();		
	elseif (id == 10) then
		-- Settings
		GnomTEC_Gnomcorder_Options["ShowDisplay"] = true;
		GnomTEC_Gnomcorder:DisplayOnOff()
		if (lastFrame and (lastFrame ~= GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS)) then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_DISPLAYCHANGE)
			lastFrame:Hide()
		end
		lastFrame = GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS
		lastFrame:Show();		
	elseif (id == 11) then
		-- prev buttonbar
		local nextButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_NEXTBAR"]
		local prevButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_PREVBAR"]
		if (actualButtonbar == 2) then
			actualButtonbar = 1
			nextButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Up")
			nextButton:SetCheckedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Up")
			nextButton:SetHighlightTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Up", "ADD")
			prevButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Disabled")
			prevButton:SetCheckedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Disabled")
			prevButton:SetHighlightTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Disabled", "DISABLE")
		end
		local i
		for i=1,6,1 do
			GnomTEC_Gnomcorder:SetIconbarButton(actualButtonbar, i, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ModuleName, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ButtonName)
		end
	elseif (id == 12) then
		-- next buttonbar
		local nextButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_NEXTBAR"]
		local prevButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_PREVBAR"]
		if (actualButtonbar == 1) then
			actualButtonbar = 2
			nextButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Disabled")
			nextButton:SetCheckedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Disabled")
			nextButton:SetHighlightTexture("Interface\\BUTTONS\\UI-SpellbookIcon-Nextpage-Disabled", "DISABLE")
			prevButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up")
			prevButton:SetCheckedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up")
			prevButton:SetHighlightTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up", "ADD")
		end
		local i
		for i=1,6,1 do
			GnomTEC_Gnomcorder:SetIconbarButton(actualButtonbar, i, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ModuleName, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ButtonName)
		end
	end
end

function GnomTEC_Gnomcorder:ModulbuttonOnEnter(id)
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	local result, moduleID, buttonID = GnomTEC_Gnomcorder:Deserialize(id)

	if ((not moduleID) or (not buttonID)) then
		GameTooltip:SetText("<ID?>")			
	elseif (not GnomTEC_Gnomcorder_Buttons[moduleID]) then
		GameTooltip:SetText("<Module?>")			
	elseif (not GnomTEC_Gnomcorder_Buttons[moduleID][buttonID]) then
		GameTooltip:SetText("<Button?>")	
	else
		GameTooltip:SetText(GnomTEC_Gnomcorder_Buttons[moduleID][buttonID].ButtonText)
	end
	GameTooltip:Show();
end

function GnomTEC_Gnomcorder:ModulbuttonOnLeave(id)
	GameTooltip:Hide();
end

function GnomTEC_Gnomcorder:ModulbuttonOnDragStop(dropedButton)
	local result, moduleID, buttonID = GnomTEC_Gnomcorder:Deserialize(dropedButton.ref:GetText())
	
	if ((not moduleID) or (not buttonID)) then
		-- no valid ID
	elseif (not GnomTEC_Gnomcorder_Buttons[moduleID]) then
		-- no valid module	
	elseif (not GnomTEC_Gnomcorder_Buttons[moduleID][buttonID]) then
		-- no valid button	
	else
		local id		
		local left, bottom, width, height = dropedButton:GetRect()
		local x = left + width / 2
		local y = bottom + height / 2
		
		
		for id=1,6, 1 do
			local checkButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BUTTON"..id]
			left, bottom, width, height = checkButton:GetRect()
			if ( (x > left) and (x < (left+width)) and (y > bottom) and (y < (bottom+height)) ) then
				GnomTEC_Gnomcorder:SetIconbarButton(actualButtonbar,id, moduleID, buttonID)
			end
		end
	end
end

	



function GnomTEC_Gnomcorder:RedrawSettings()

	settingsPosition = floor(GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_SLIDER:GetValue())


	local m = 0		
	local moduleKey, moduleValue
	for moduleKey,moduleValue in pairs(GnomTEC_Gnomcorder_Buttons) do
		m = m + 1
		if (((m - settingsPosition) > 0) and ((m - settingsPosition) < 9)) then
			local frame = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition)]
			local name = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition).."_NAME"]
			name:SetText(moduleKey);
			frame:Show()
		
			local b = 1
			local buttonKey, buttonValue
			for buttonKey,buttonValue in pairs(moduleValue) do
				if ( b < 6) then
					local checkButton = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition).."_BUTTON"..b.."_BUTTON"]
					local ref = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition).."_BUTTON"..b.."_BUTTON_REF"]
					checkButton:SetNormalTexture(buttonValue.NormalTexture)
					checkButton:SetHighlightTexture(buttonValue.NormalTexture, "ADD")
					checkButton:SetCheckedTexture(buttonValue.CheckedTexture)
					ref:SetText(GnomTEC_Gnomcorder:Serialize(moduleKey, buttonKey))
					checkButton:Show()
					-- workaround to reposition buttons and connect them to frame
					checkButton:ClearAllPoints();
					checkButton:SetPoint("TOPLEFT");

				end
				b = b + 1
			end
			while (b < 6) do
					local checkButton = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition).."_BUTTON"..b.."_BUTTON"]
					checkButton:Hide()
					b = b + 1
			end
		end
	end
	
	if (m > 8) then
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_SLIDER:SetMinMaxValues(0,m-8);
	else
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_SLIDER:SetMinMaxValues(0,0);		
	end
		
	while (((m - settingsPosition) > 0) and ((m - settingsPosition) < 8)) do
		m = m + 1
		local frame = _G["GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_MODUL"..(m - settingsPosition)]
		frame:Hide()
	end
		
end

local function SetDesaturation(texture, desaturation)
	local shaderSupported = texture:SetDesaturated(desaturation);
	if ( not shaderSupported ) then
		if ( desaturation ) then
			texture:SetVertexColor(0.5, 0.5, 0.5);
		else
			texture:SetVertexColor(1.0, 1.0, 1.0);
		end
	end		
end

function GnomTEC_Gnomcorder:SetIconbarButton(bar, id, moduleName, buttonName)
	if ((id > 0) and (id < 7) and (bar > 0) and (bar < 3)) then
		local checkButton = _G["GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BUTTON"..id]
		local desaturation = true
		
		if (bar == actualButtonbar) then
			checkButton:SetNormalTexture("Interface\\BUTTONS\\ButtonHilight-Square")		
			checkButton:SetCheckedTexture("Interface\\BUTTONS\\ButtonHilight-Square")
			checkButton:SetHighlightTexture("Interface\\BUTTONS\\ButtonHilight-Square", "ADD")
		end
		
		if (GnomTEC_Gnomcorder_Buttons[moduleName]) then
			if (GnomTEC_Gnomcorder_Buttons[moduleName][buttonName]) then
				local button = GnomTEC_Gnomcorder_Buttons[moduleName][buttonName]
				GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..bar]["Button"..id].ModuleName = moduleName
				GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..bar]["Button"..id].ButtonName = buttonName
				
				desaturation = (nil == button.Frame) and (nil == button.OnClick)
				
				if (bar == actualButtonbar) then
					checkButton:SetNormalTexture(button.NormalTexture)
					if (not button.Checked) then
						checkButton:SetHighlightTexture(button.NormalTexture, "ADD")
					end
					checkButton:SetCheckedTexture(button.CheckedTexture)
					if (button.Checked) then
						checkButton:SetHighlightTexture(button.CheckedTexture, "ADD")
					end
					checkButton:SetChecked(button.Checked);
				end
			end
		end
		
		if (bar == actualButtonbar) then
			SetDesaturation(checkButton:GetNormalTexture(), desaturation)
			SetDesaturation(checkButton:GetCheckedTexture(), desaturation)
			SetDesaturation(checkButton:GetHighlightTexture(), desaturation)	
		end
	end
end

function GnomTEC_Gnomcorder:AddButton(moduleName, buttonName, buttonText, frame, normalTexture, checkedTexture, checked, onClick, timerEvent)
	if ((emptynil(moduleName)  ~= nil) and (emptynil(buttonName) ~= nil)) then
		if (not GnomTEC_Gnomcorder_Buttons[moduleName]) then 
			GnomTEC_Gnomcorder_Buttons[moduleName] = {}
		end
		if (not GnomTEC_Gnomcorder_Buttons[moduleName][buttonName]) then 
			GnomTEC_Gnomcorder_Buttons[moduleName][buttonName] = {}
		end
		
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].ButtonText = emptynil(buttonText)
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].Frame = emptynil(frame)
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].NormalTexture = (emptynil(normalTexture) or "Interface\\ICONS\\INV_Misc_QuestionMark")
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].CheckedTexture = (emptynil(checkedTexture) or "Interface\\ICONS\\INV_Misc_QuestionMark")
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].Checked = checked		
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].OnClick = emptynil(onClick)	
		GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].TimerEvent = emptynil(timerEvent)	
		
		if (GnomTEC_Gnomcorder_Buttons[moduleName][buttonName].Frame) then
			frame:SetParent(GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW)
			frame:SetPoint("TOPLEFT")			
		end
		
		settingsPosition = 0
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_SETTINGS_MODULS_SLIDER:SetValue(settingsPosition)
		GnomTEC_Gnomcorder:RedrawSettings()
		
		-- set buttons on iconbar (for actualize yet greyed buttons)
		local i
		for i=1,6,1 do
			GnomTEC_Gnomcorder:SetIconbarButton(actualButtonbar, i, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ModuleName, GnomTEC_Gnomcorder_IconbarButtons["Buttonbar"..actualButtonbar]["Button"..i].ButtonName)
		end

-- zum Test erstmal dann direkt hinzufügen
--		if (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button1"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,1, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button2"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,2, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button3"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,3, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button4"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,4, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button5"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,5, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar1"]["Button6"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(1,6, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button1"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,1, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button2"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,2, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button3"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,3, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button4"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,4, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button5"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,5, moduleName, buttonName)
--		elseif (not GnomTEC_Gnomcorder_IconbarButtons["Buttonbar2"]["Button6"]["ModuleName"]) then
--			GnomTEC_Gnomcorder:SetIconbarButton(2,6, moduleName, buttonName)
--		end			

	end
end

function GnomTEC_Gnomcorder:UpdateBattery()
	local t = GetTime()
		
	local color
	if (GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_4_MINVALUE) then
		color = "|cff00ff00"
	elseif(GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_3_MINVALUE) then
		color = "|cffffff00"
	elseif(GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_2_MINVALUE) then
		color = "|cffff8000"
	else
		color = "|cffff0000"
	end		
		
	local percent = floor((GnomTEC_Gnomcorder_Options["Battery"] / CONST_BATTERY_FULL) * 1000) / 10

	GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_ENERGY:SetText(L["L_BATTERY_ENERGY"]..color..percent.."% ("..floor(GnomTEC_Gnomcorder_Options["Battery"]).." "..L["L_BATTERY_ENERGY_UNIT"]..")")

	if (t-battery_lasttime_time > 60) then

		-- consume energy for every module
		local key, value
		for key,value in pairs(GnomTEC_Gnomcorder_Buttons) do
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_MODULEPERHOUR * ((t-battery_lasttime_time)/(60*60)))
		end
		-- consum energy when display is shown
		if (GnomTEC_Gnomcorder_Options["ShowDisplay"]) then
			GnomTEC_Gnomcorder:ConsumeBattery(CONST_BATTERY_CONSUMPTION_MODULEPERHOUR * ((t-battery_lasttime_time)/(60*60)))		
		end

		local consumption_startup = floor((battery_startup_energy-GnomTEC_Gnomcorder_Options["Battery"]) / ((t-battery_startup_time)/(60*60)))
		local consumption_lasttime = floor((battery_lasttime_energy-GnomTEC_Gnomcorder_Options["Battery"]) / ((t-battery_lasttime_time)/(60*60)))
		local duration
		
		if (consumption_lasttime > 0) then
			duration = floor(GnomTEC_Gnomcorder_Options["Battery"] / consumption_lasttime * 10) / 10
		elseif (consumption_startup > 0) then
			duration = floor(GnomTEC_Gnomcorder_Options["Battery"] / consumption_startup * 10) / 10
		else
			duration = 0
		end
			
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_CONSUMPTION_STARTUP:SetText(L["L_BATTERY_USE_STARTUP"]..consumption_startup.." "..L["L_BATTERY_ENERGY_UNIT_PER_HOUR"])
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_CONSUMPTION_LASTTIME:SetText(L["L_BATTERY_USE_ACTUAL"]..consumption_lasttime.." "..L["L_BATTERY_ENERGY_UNIT_PER_HOUR"])
		GNOMTEC_GNOMCORDER_FRAME_DISPLAY_VIEW_BATTERY_DURATION:SetText(L["L_BATTERY_DURATION"]..duration.." "..L["L_BATTERY_HOURS"])

		battery_lasttime_energy = GnomTEC_Gnomcorder_Options["Battery"]
		battery_lasttime_time = t	
	end

	if (GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_5_MINVALUE) then
		if (battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_5_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_5_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_5_TEXTURE)
	elseif (GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_4_MINVALUE) then
		if (battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_4_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_4_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_4_TEXTURE)
	elseif(GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_3_MINVALUE) then
		if (battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_3_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_3_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_3_TEXTURE)
	elseif(GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_2_MINVALUE) then
		if (not battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
--			battery_blink = 1
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_2_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_2_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_2_TEXTURE)
	elseif(GnomTEC_Gnomcorder_Options["Battery"] > CONST_BATTERY_1_MINVALUE) then
		if (not battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
--			battery_blink = 1
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_1_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_1_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_1_TEXTURE)
	else
		if (not battery_blink) then
			GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:UnlockHighlight();
			battery_blink = nil
--			battery_blink = 1
		end
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetNormalTexture(CONST_BATTERY_0_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetHighlightTexture(CONST_BATTERY_0_TEXTURE)
		GNOMTEC_GNOMCORDER_FRAME_ICONBAR_BATTERY:SetCheckedTexture(CONST_BATTERY_0_TEXTURE)
	end
end

function GnomTEC_Gnomcorder:ConsumeBattery(amount)
	if ( GnomTEC_Gnomcorder_Options["Battery"] >= amount) then
		GnomTEC_Gnomcorder_Options["Battery"] = GnomTEC_Gnomcorder_Options["Battery"] - amount
	else
		amount = 0
	end
	return amount
end

function GnomTEC_Gnomcorder:RechargeBattery(amount)
	if ((GnomTEC_Gnomcorder_Options["Battery"] + amount) <= CONST_BATTERY_FULL) then
		GnomTEC_Gnomcorder_Options["Battery"] = GnomTEC_Gnomcorder_Options["Battery"] + amount
	else
		GnomTEC_Gnomcorder_Options["Battery"] = CONST_BATTERY_FULL
	end
	return amount
end

function GnomTEC_Gnomcorder:RechargeButton(amount)
--[[ GUIDs are changed in 6.0.2 so this is not working anymore
    local guid = UnitGUID("target")	
    local creatureID = ""

	if (guid) then
		local first3 = tonumber("0x"..strsub(guid, 3,5))
		local unitType = bit.band(first3,0x00f)
		if (unitType == 0x003) then
    		creatureID = "NPC_"..tonumber("0x"..strsub(guid,7,10))
    	end
    end
    
    if ((CONST_BATTERY_RECHARGER_NPC[creatureID]) and (CheckInteractDistance("target", 2))) then
    	-- geiegneter NPC im target
    	battery_recharging = GetTime()
    	
    else
    	-- NPC nicht verfügbar oder nicht nahe genug
    	battery_recharging = nil
    end
--]]
end

